function SetAppsDisplay(xml)
{
displayElementRootNames = new Array();
}

function Python_InstalledScripts_Render(xml)
{
var r = '';
if(! xml || ! xml.hasChildNodes())
{
r += "<p>No installed packages</p>";
var d = document.getElementById('installed_python_packages');
d.innerHTML=r;
}
else
{
var s="";
r = "<table class='basicTable'>";
for(var i = 0; xml && i < xml.childNodes.length; ++i)
{
var node = xml.childNodes[i];
var installedPackages=0;
if(node.nodeName.toLowerCase() == "script")
{
var identifier=GetXmlData(node,"index");
var state=GetXmlData(node,"state");
var filename=GetXmlData(node,"filename");
var parameters=GetXmlData(node,"parameters");
var output=GetXmlData(node,"output");
var onstart=GetXmlData(node,"onstart");
var onshutdown=GetXmlData(node,"onshutdown");

s += "<tr class='statusHeader'>";
s += "<td width='40%'><b>Script "+(parseInt(identifier)+1)+"</b></td>";
s += "<td align='right'>";
s += "<input id='run'";
s += " onclick=\"if(confirm('Are you SURE you want to run this script?')){this.blur();FileSystemMonitor();return ajax_AppsRun([true,'type=python&amp;instance="+identifier+"']);}return false;\"";
s += " type='button' name='submit' value='Run'/>";
s += "</td>";
s += "</tr>";

s += "<tr><td colspan='2'>";
s += "<input type='checkbox' ";
s += "onclick='updateButtonVisibilities(\"appsform\",\"submit_changes\",\"cancel_changes\");' name='script_state." + identifier +"' org_state='"+state+"' ";
if(state=="true")s += " checked ";
s += "/><b>Enabled</b>";
s += "&nbsp;&nbsp;&nbsp;&nbsp;";
s += "<input type='checkbox' ";
s += "onclick='updateButtonVisibilities(\"appsform\",\"submit_changes\",\"cancel_changes\");' name='script_onstart." + identifier +"' org_state='"+onstart+"' ";
if(onstart=="true")s += " checked ";
s += "/><b>Run on startup</b>";

s += "&nbsp;&nbsp;&nbsp;&nbsp;";
s += "<input type='checkbox' ";
s += "onclick='updateButtonVisibilities(\"appsform\",\"submit_changes\",\"cancel_changes\");' name='script_onshutdown." + identifier +"' org_state='"+onshutdown+"' ";
if(onshutdown=="true")s += " checked ";
s += "/><b>Run on shutdown</b>";
s += "</td></tr>";

s += "<tr><td width='40%'><b>Script</b></td>";
s += "<td><input type='text' size='32' maxlength='64' name='script_filename."+identifier+"' org_value='"+filename+"' value='"+filename+"' ";
s += "onkeyup='updateButtonVisibilities(\"appsform\",\"submit_changes\",\"cancel_changes\");'/></td></tr>";
s += "<tr><td><b>Parameters</b></td>";
s += "<td><input type='text' size='32' maxlength='64' name='script_parameters."+identifier+"' org_value='"+parameters+"' value='"+parameters+"' ";
s += "onkeyup='updateButtonVisibilities(\"appsform\",\"submit_changes\",\"cancel_changes\");'/></td></tr>";
s += "<tr><td width='40%'><b>Output</b></td>";
s += "<td><input type='text' size='32' maxlength='64' name='script_output."+identifier+"' org_value='"+output+"' value='"+output+"' ";
s += "onkeyup='updateButtonVisibilities(\"appsform\",\"submit_changes\",\"cancel_changes\");'/></td></tr>";
}
}
r += s;
r += "</table>";
var d = document.getElementById('installed_python_scripts');
d.innerHTML=r;
updateButtonVisibilities('appsform','submit_changes','cancel_changes');
document.getElementById("appsform").style.display = "block";

document.getElementById("importform").reset();
updateButtonVisibilities('importform','install','uninstall');
document.getElementById("importform").style.display = "block";
document.getElementById("uninstallform").style.display = "block";

}
}
function Python_InstalledApps_Render(xml)
{
var r = '';
if(! xml || ! xml.hasChildNodes())
{
r += "<p>No installed packages</p>";
var d = document.getElementById('installed_python_packages');
d.innerHTML=r;
}
else
{
var s='';
var installedPackages=0;
s = "<table class='basicTable'>";
for(var i = 0; xml && i < xml.childNodes.length; ++i)
{
var node = xml.childNodes[i];
if(node.nodeName.toLowerCase() == "package")
{
var file=GetXmlData(node,"file");
s += "<tr class='statusHeader'><td width='40%'>";
s += "<b>Package:</b></td>";
s += "<td align='right'>";
s += "<input id='uninstall'";
s += " onclick=\"if(confirm('Are you SURE you want to uninstall this package?')){this.blur();FileSystemMonitor();return ajax_AppsInstall([true,'package="+file+"&amp;type=python&amp;mode=egg-info&amp;action=uninstall']);}return false;\"";
s += " type='submit' name='submit' value='Uninstall'/>";
/*s += "<a href=\"javascript:void(0)\" ";
s += " onclick=\"if(confirm('Are you SURE you want to uninstall this package?')){this.blur();FileSystemMonitor();return ajax_AppsInstall([true,'package="+file+"&amp;type=python&amp;mode=egg-info&amp;action=uninstall']);}return false;\"";
s += ">";
s += '<img class="fsimage" src="/config/delete-icon.gif" width="20" height="20"/><br/>';
s += "</a>";*/
s += "</td></tr>";
s += "<tr><td width='40%'><b>File</b></td><td>"+file+"</td></tr>";
var name=GetXmlData(node,"name");
if(name)s += "<tr><td width='40%'><b>Name</b></td><td>"+name+"</td></tr>";
var version=GetXmlData(node,"version");
if(version)s += "<tr><td width='40%'><b>Version</b></td><td>"+version+"</td></tr>";
var summary=GetXmlData(node,"summary");
if(summary)s += "<tr><td width='40%'><b>Summary</b></td><td>"+summary+"</td></tr>";
installedPackages++;
}
if(node.nodeName.toLowerCase() == "python")
{
var installed=GetXmlData(node,"installed");
if(installed=="true")
{
s += "<tr class='statusHeader'><td width='40%'>";
s += "<b>Package:</b>";
s += "</td>";
s += "<td align='right'>";
s += "</td></tr>";
s += "<tr><td width='40%'><b>File</b></td><td>Python</td></tr>";
s += "<tr><td width='40%'><b>Version</b></td><td>2.7.3</td></tr>";
installedPackages++;
}
}
}
s += "</table>";
r += s;
if(installedPackages==0)
{
r = "<p>Python package not installed</p>";
}
else
{
r += "<input id='uninstall'";
r += " onclick=\"if(confirm('Are you SURE you want to uninstall Python and all installed packages?')){this.blur();FileSystemMonitor();return ajax_AppsInstall([true,'package=python&amp;type=python&amp;mode=python&amp;action=uninstall']);}return false;\"";
r += " type='submit' name='submit' value='Remove all'/>";
/*r += "<a href=\"javascript:void(0)\" ";
r += " onclick=\"if(confirm('Are you SURE you want to uninstall Python and all installed packages?')){this.blur();FileSystemMonitor();return ajax_AppsInstall([true,'package=python&amp;type=python&amp;mode=python&amp;action=uninstall']);}return false;\"";
r += ">";
r += '<img class="fsimage" src="/config/delete-icon.gif" width="20" height="20"/><br/>';
r += "</a>";*/
}
var d = document.getElementById('installed_python_packages');
d.innerHTML=r;
}
}
